<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Lifinity Dungeon: He_Arc::RPG::Game Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Lifinity Dungeon
   &#160;<span id="projectnumber">6</span>
   </div>
   <div id="projectbrief">The Lifinity Dungeon is a dungeon with an infinity of room. After each room, you found a harder room. This is why you will pass the eternity of your life in this dungeon</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><b>He_Arc</b></li><li class="navelem"><b>RPG</b></li><li class="navelem"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="class_he___arc_1_1_r_p_g_1_1_game-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">He_Arc::RPG::Game Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This class is the game logic implementation, It regroups each classes and interconnect them to perform a complet game.  
 <a href="class_he___arc_1_1_r_p_g_1_1_game.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_game_8hpp_source.html">Game.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a497fbf3e1aa8cde7c5ad1c1556535230"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html#a497fbf3e1aa8cde7c5ad1c1556535230">Game</a> (int nbAlly=4)</td></tr>
<tr class="memdesc:a497fbf3e1aa8cde7c5ad1c1556535230"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a new <a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html" title="This class is the game logic implementation, It regroups each classes and interconnect them to perfor...">Game</a> object.  <a href="class_he___arc_1_1_r_p_g_1_1_game.html#a497fbf3e1aa8cde7c5ad1c1556535230">More...</a><br /></td></tr>
<tr class="separator:a497fbf3e1aa8cde7c5ad1c1556535230"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9a89f5c68680c2e133306d6a3db5043a"><td class="memItemLeft" align="right" valign="top"><a id="a9a89f5c68680c2e133306d6a3db5043a"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>Game</b> (const <a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a> &amp;game)</td></tr>
<tr class="separator:a9a89f5c68680c2e133306d6a3db5043a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afda0db7e4efeba899d71a140c4bbfde5"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html#afda0db7e4efeba899d71a140c4bbfde5">GetGameLevel</a> ()</td></tr>
<tr class="memdesc:afda0db7e4efeba899d71a140c4bbfde5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the level of the game.  <a href="class_he___arc_1_1_r_p_g_1_1_game.html#afda0db7e4efeba899d71a140c4bbfde5">More...</a><br /></td></tr>
<tr class="separator:afda0db7e4efeba899d71a140c4bbfde5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a36522842eab3b4291b577a98a16f7672"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html#a36522842eab3b4291b577a98a16f7672">operator=</a> (const <a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a> &amp;game)</td></tr>
<tr class="memdesc:a36522842eab3b4291b577a98a16f7672"><td class="mdescLeft">&#160;</td><td class="mdescRight">The assignation (in depth) of a game (copy)  <a href="class_he___arc_1_1_r_p_g_1_1_game.html#a36522842eab3b4291b577a98a16f7672">More...</a><br /></td></tr>
<tr class="separator:a36522842eab3b4291b577a98a16f7672"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c8d4e121c2e3f221211874510f8b3bd"><td class="memItemLeft" align="right" valign="top"><a id="a5c8d4e121c2e3f221211874510f8b3bd"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html#a5c8d4e121c2e3f221211874510f8b3bd">CreateTeamComposition</a> ()</td></tr>
<tr class="memdesc:a5c8d4e121c2e3f221211874510f8b3bd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a the team of the player (add new character to the team) When calling, the current team is cleaned. <br /></td></tr>
<tr class="separator:a5c8d4e121c2e3f221211874510f8b3bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acff32587086411e092dd1941200e07f4"><td class="memItemLeft" align="right" valign="top"><a id="acff32587086411e092dd1941200e07f4"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html#acff32587086411e092dd1941200e07f4">EnterFightingRoom</a> ()</td></tr>
<tr class="memdesc:acff32587086411e092dd1941200e07f4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Go to a fight room, this function will set the ennemy team, and prepare the room for fighting. <br /></td></tr>
<tr class="separator:acff32587086411e092dd1941200e07f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d8fcb94b0e125745221bbd497ae7d20"><td class="memItemLeft" align="right" valign="top"><a id="a7d8fcb94b0e125745221bbd497ae7d20"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html#a7d8fcb94b0e125745221bbd497ae7d20">DisplayFight</a> () const</td></tr>
<tr class="memdesc:a7d8fcb94b0e125745221bbd497ae7d20"><td class="mdescLeft">&#160;</td><td class="mdescRight">Display the GUI for the fight. <br /></td></tr>
<tr class="separator:a7d8fcb94b0e125745221bbd497ae7d20"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd2cde00f0f0f39832b4f7932792bad9"><td class="memItemLeft" align="right" valign="top"><a id="afd2cde00f0f0f39832b4f7932792bad9"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html#afd2cde00f0f0f39832b4f7932792bad9">PerformGameTurn</a> ()</td></tr>
<tr class="memdesc:afd2cde00f0f0f39832b4f7932792bad9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Perform a complet game turn (player turn and monster turn) <br /></td></tr>
<tr class="separator:afd2cde00f0f0f39832b4f7932792bad9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeb8e95a303cd2c377d0a638f8da055d6"><td class="memItemLeft" align="right" valign="top"><a class="el" href="_enums_8hpp.html#ad46aac46ff35875d2e579285bc6289b9">TeamGrp</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html#aeb8e95a303cd2c377d0a638f8da055d6">ThereIsDeadTeam</a> ()</td></tr>
<tr class="memdesc:aeb8e95a303cd2c377d0a638f8da055d6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Is a team is dead (each character dead)  <a href="class_he___arc_1_1_r_p_g_1_1_game.html#aeb8e95a303cd2c377d0a638f8da055d6">More...</a><br /></td></tr>
<tr class="separator:aeb8e95a303cd2c377d0a638f8da055d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a569c01c42d8f0eec432d724f017b882d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html#a569c01c42d8f0eec432d724f017b882d">IsDeadTeam</a> (vector&lt; shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt;&gt; team)</td></tr>
<tr class="memdesc:a569c01c42d8f0eec432d724f017b882d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Is all character in the team are dead (hp &lt;= 0)  <a href="class_he___arc_1_1_r_p_g_1_1_game.html#a569c01c42d8f0eec432d724f017b882d">More...</a><br /></td></tr>
<tr class="separator:a569c01c42d8f0eec432d724f017b882d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4cdbe2413a1a375c938c6c89e6304ce5"><td class="memItemLeft" align="right" valign="top"><a id="a4cdbe2413a1a375c938c6c89e6304ce5"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html#a4cdbe2413a1a375c938c6c89e6304ce5">IncreaseGameLevel</a> ()</td></tr>
<tr class="memdesc:a4cdbe2413a1a375c938c6c89e6304ce5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Increase the level of the game by 1. <br /></td></tr>
<tr class="separator:a4cdbe2413a1a375c938c6c89e6304ce5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a187d52b0b5b5da08096f9d335df29207"><td class="memItemLeft" align="right" valign="top"><a id="a187d52b0b5b5da08096f9d335df29207"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html#a187d52b0b5b5da08096f9d335df29207">PerformStartRoom</a> ()</td></tr>
<tr class="memdesc:a187d52b0b5b5da08096f9d335df29207"><td class="mdescLeft">&#160;</td><td class="mdescRight">Do the action to enter into a room, do the fight, and finally finish the room. <br /></td></tr>
<tr class="separator:a187d52b0b5b5da08096f9d335df29207"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3b52b19924c77f007b334c21e0802af2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html#a3b52b19924c77f007b334c21e0802af2">HealPlayer</a> (int amount)</td></tr>
<tr class="memdesc:a3b52b19924c77f007b334c21e0802af2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Heal the whole player's team (No check if character deads; they will be healed too; --&gt; Miracle, he resuscitated)  <a href="class_he___arc_1_1_r_p_g_1_1_game.html#a3b52b19924c77f007b334c21e0802af2">More...</a><br /></td></tr>
<tr class="separator:a3b52b19924c77f007b334c21e0802af2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class is the game logic implementation, It regroups each classes and interconnect them to perform a complet game. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a497fbf3e1aa8cde7c5ad1c1556535230"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a497fbf3e1aa8cde7c5ad1c1556535230">&#9670;&nbsp;</a></span>Game()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Game::Game </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>nbAlly</em> = <code>4</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct a new <a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html" title="This class is the game logic implementation, It regroups each classes and interconnect them to perfor...">Game</a> object. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">nbAlly</td><td>The number of ally available when creating the team </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="afda0db7e4efeba899d71a140c4bbfde5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afda0db7e4efeba899d71a140c4bbfde5">&#9670;&nbsp;</a></span>GetGameLevel()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Game::GetGameLevel </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the level of the game. </p>
<dl class="section return"><dt>Returns</dt><dd>int level of the game </dd></dl>

</div>
</div>
<a id="a3b52b19924c77f007b334c21e0802af2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3b52b19924c77f007b334c21e0802af2">&#9670;&nbsp;</a></span>HealPlayer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Game::HealPlayer </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>amount</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Heal the whole player's team (No check if character deads; they will be healed too; --&gt; Miracle, he resuscitated) </p>
<dl class="section remark"><dt>Remarks</dt><dd>(resusciated character in fight is not handled; he will only be able to participate in the fight of the next room !)</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">amount</td><td>How many health are given to the team of the player </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a569c01c42d8f0eec432d724f017b882d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a569c01c42d8f0eec432d724f017b882d">&#9670;&nbsp;</a></span>IsDeadTeam()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Game::IsDeadTeam </td>
          <td>(</td>
          <td class="paramtype">vector&lt; shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt;&gt;&#160;</td>
          <td class="paramname"><em>team</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Is all character in the team are dead (hp &lt;= 0) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">team</td><td>team to analyse </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true All characters of the team are dead </dd>
<dd>
false Team have at least 1 character alive </dd></dl>

</div>
</div>
<a id="a36522842eab3b4291b577a98a16f7672"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a36522842eab3b4291b577a98a16f7672">&#9670;&nbsp;</a></span>operator=()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a> &amp; Game::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a> &amp;&#160;</td>
          <td class="paramname"><em>game</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The assignation (in depth) of a game (copy) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">game</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><a class="el" href="class_he___arc_1_1_r_p_g_1_1_game.html" title="This class is the game logic implementation, It regroups each classes and interconnect them to perfor...">Game</a>&amp; </dd></dl>

</div>
</div>
<a id="aeb8e95a303cd2c377d0a638f8da055d6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aeb8e95a303cd2c377d0a638f8da055d6">&#9670;&nbsp;</a></span>ThereIsDeadTeam()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="_enums_8hpp.html#ad46aac46ff35875d2e579285bc6289b9">TeamGrp</a> Game::ThereIsDeadTeam </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Is a team is dead (each character dead) </p>
<dl class="section return"><dt>Returns</dt><dd>TeamGrp The dead team indicator </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>cpp_filrouge_iscj_allemann/include/<a class="el" href="_game_8hpp_source.html">Game.hpp</a></li>
<li>cpp_filrouge_iscj_allemann/src/<a class="el" href="_game_8cpp.html">Game.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
